/*

  File: InventorWriter.h

  (c) 2003 by Oliver Ehli

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     See File LICENSE for more Information.

*/
#ifndef INVENTOR_WRITER_H_
#define INVENTOR_WRITER_H_


#ifdef DEBUG_BIN

class InventorWriter
{
 public:

  static void writeColor(ofstream & out, int whatColor);
  static void writeRGBColor(ofstream & out, float r, float g, float b, float a=0.5);
  static void writeTranslation(ofstream & out, float x, float y, float z);
  static void writeCube(ofstream & out, float xSize=2, float ySize=2, float zSize=2);
  static void writeBBox(ofstream & out, int indentLevel, int bbox[3]);

  static char *header;
  static char *footer;
  static char *beginGroup;
  static char *endGroup;
  static char *indent;

  static float baseUnit;

  static float colors[][3];

};

#endif
#endif
