/*

  File: Puzzle.h

  (c) 2003 by Oliver Ehli

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     See File LICENSE for more Information.

*/
#ifndef PUZZLE_H_
#define PUZZLE_H_

// Maximum Piece-Bounding-Box
#define PC_X_DIM       4
#define PC_Y_DIM       3
#define PC_Z_DIM       2

#define NUM_PCS       12
#define MAX_NUM_ROT   256
#define MAX_NUM_POS   576

// GameCube(tm :-) size
#define GC_X_DIM       3
#define GC_Y_DIM       4
#define GC_Z_DIM       5


/* #define GC_X_DIM       2 */
/* #define GC_Y_DIM       5 */
/* #define GC_Z_DIM       6 */


class Puzzle
{

 public: 

  struct PieceDescription {
    int   (* bbox)[3];
    bool  (* positions)[PC_Z_DIM][PC_Y_DIM][PC_X_DIM];
  };

  static inline const PieceDescription* getPieces() { return piece_desc; };

  static long long rotate(long long piece, int xAngle, int yAngle, int zAngle,
		     int bbox[], int xMask);

 private:

  static long long xRotate(long long piece, int xAngle, int yAngle, int zAngle,
			   int bbox[], int xMask);
  static long long yRotate(long long piece, int xAngle, int yAngle, int zAngle,
			   int bbox[], int xMask);
  static long long zRotate(long long piece, int xAngle, int yAngle, int zAngle,
			   int bbox[], int xMask);

  static long long translateToOrigin(long long piece);

  Puzzle();

  static PieceDescription piece_desc[];

};


#endif
