/*

  File: Solver.h

  (c) 2003 by Oliver Ehli

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     See File LICENSE for more Information.

*/
#ifndef SOLVER_H_
#define SOLVER_H_


class Solver {

 public:

  Solver(Piece **inPieces);

  int solve();

  bool ctSolve();

  long long getCtSolution() {return ctSolution; }

  int getNumSolutions() {return numSolutions; }


 private:

  inline void placePiece(int pieceNo, int start, long long startMask, long long puzzle, int partsUsed);

  void doSolve(int start, long long startMask, long long puzzle, int partsUsed);

  void checkGameStatus(char *op = "init");
  void writePositionAsIV();

  static int partMask[NUM_PCS];
  static int allParts;
  int currentPositions[NUM_PCS];
  int partsUsed;
  int currentDepth;
  int numSolutions;
  long long ctSolution;

  Piece **pieces;

};

#endif
