/*

  File: createSolver.h

  (c) 2003 by Oliver Ehli

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     See File LICENSE for more Information.

*/
char solver_head[] =
"#include <stdio.h>\n"
"#include <unistd.h>\n"
"#include <time.h>\n"
"\n"
"#define NUM_PCS 12\n"
"#define START 4\n"
"#define NUM_BITS 60\n"
"#define NUM_HI_BITS 32\n"
"#define NUM_LO_BITS 32\n"
"\n"
"\n"
"int percent = 0;\n"
"int partsUsed = 0;\n"
"int numSolutions = 0;\n"
"clock_t startTime;\n"
"double correction[] = { 1.26, 1.05, 1, 0.94, 0.97, 1.005, 0.985, 0.94, 0.95, 1 };\n"
"\n"
"\n"
"\n"
"extern void solve();\n"
"\n"
"extern void doSolve(int start, long long startMask, long long puzzle, int partsUsed);\n"
"extern void altDoSolve(int start, long long startMask, long long puzzle, int partsUsed);\n"
"\n"
"extern void doSolve32(int start, int startMask, int puzzle, int partsUsed);\n"
"extern void altDoSolve32(int start, int startMask, int puzzle, int partsUsed);\n"
"\n"
"\n"
"int main(int argc, char**argv)\n"
"{\n"
"  clock_t startTime = clock();\n"
"\n"
"  solve();\n"
"\n"
"  printf(\"\\ndone. %%ld seconds, %%ld solutions.\\n\", \n"
"	 (clock()-startTime)/1000000, numSolutions);\n"
"}\n"
"\n"
"\n"
"\n";


char solverStart1[] =
"oSolve(int start, long long startMask, long long puzzle, int partsUsed)\n"
"{\n"
"  for (;(puzzle & startMask) && start < NUM_LO_BITS; start++, startMask <<= 1);\n"
"\n"
"  if(start == NUM_LO_BITS) {\n"
"    ";
char solverStart2[] =
"oSolve32(0, 1, puzzle>>NUM_LO_BITS, partsUsed);\n"
"    return;\n"
"  }\n"
"\n";


char solver32Start[] =
"oSolve32(int start, int startMask, int puzzle, int partsUsed)\n"
"{\n"
"  for (;(puzzle & startMask) && start < NUM_HI_BITS; start++, startMask <<= 1);\n"
"  if(partsUsed == (1<<12)-1) {\n"
"    if(!(++numSolutions%4099)) { write(0, \".\", 1); }\n"
"    if(!((numSolutions) % (409963/10))) {\n"
"      percent++;\n"
"      printf(\"\\r%d%% done, %ld seconds so far; expecting %.0lf seconds.\\n\", \n"
"	     percent*10, (clock()-startTime)/1000000, ((double)(clock()-startTime)/100000/percent)*correction[percent-1]);\n"
"      fflush(stdout);\n"
"    }\n"
"    return;\n"
"  }\n";
